/* lexical analyzer for dlg for ee595e
 * This lexical analyzer is looking for the tokens from the ALX
 * specifications
 *
 * Will Cohen
 * 10/3/89
 */

#include <stdio.h>
#include "dlg.h"
#include "tokens.h"

#define ishex(c)	(c>='0' && c<='9' || c>='a'&& c<='f' || c>='A' && \
				c<='F')
#define isoct(c)	(c>='0' && c<='7')
#define isdec(c)	(c>='0' && c<='9')

int	line_no = 1;		/* keep track of what line advance is on */
int token;
static int look_ahead = EOF;	/* used for two char tokens */

advance()
{
/* generally gets single characters, but will get tokens too */

ignore:	if (look_ahead != EOF){
		/* make it the current token and see what it is */
		token = look_ahead;
		look_ahead = EOF;
		}
	else
		token = getc(IN);
	/* do special cases and conver things into tokens */
	switch (token){
	case '<':	if ((look_ahead = getc(IN)) == '<'){
				token = LESS_LESS;
				look_ahead = EOF;
				}
			break;
	case '>':	if ((look_ahead = getc(IN)) == '>'){
				token = GREAT_GREAT;
				look_ahead = EOF;
				}
			break;
	case '%':	if ((look_ahead = getc(IN)) == '%'){
				token = PER_PER;
				look_ahead = EOF;
				}
			break;
	case EOF:	token = THE_EOF;
			break;
	case '@':	token = LEX_EOF;
			break;
	case '[':	token = OPEN_BRACK;
			break;
	case ']':	token = CLOSE_BRACK;
			break;
	case '(':	token = OPEN_PAR;
			break;
	case ')':	token = CLOSE_PAR;
			break;
	case '{':	token = OPEN_BRACE;
			break;
	case '}':	token = CLOSE_BRACE;
			break;
	case '*':	token = ZERO_MORE;
			break;
	case '+':	token = ONE_MORE;
			break;
	case '-':	token = RANGE;
			break;
	case '|':	token = OR;
			break;
	case '~':	token = NOT;
			break;
	/* not the best solution but ' ' and tabs are ignored */
	case '\r':
	case '\n':	++line_no;
	case ' ':
	case '\t':	goto ignore;
	case '\\':	look_ahead = getc(IN);
			if (look_ahead == '0'){
				/* could be hex or octal */
				look_ahead = getc(IN);
				if (look_ahead == 'x'){
					look_ahead = getc(IN);
					in_hex();
					}
				else
					in_oct();
				}
			else if(isdec(look_ahead))
					in_dec();
			else{
				switch(look_ahead){
				case 'n':	token = '\n';
						break;
				case 't':	token = '\t';
						break;
				case 'b':	token = '\b';
						break;
				case 'r':	token = '\r';
						break;
				case 'f':	token = '\f';
						break;
				default:
						token = look_ahead;
				}
				look_ahead = EOF;
				}
			break;
	}
}

in_hex()
{	register c = look_ahead;
	int d;

	token = 0;
	while (ishex(look_ahead)){
		if (c>='0' && c<='9')
			d = c - '0';
		else if (c>='a' && c<='f')
			d = c - 'a' + 10;
		else if (c>='A' && c<='F')
			d = c - 'A' + 10;
		token = token*16 + d;
		c = look_ahead = getc(IN);
	}
}

in_oct()
{
	token = 0;
	while (isoct(look_ahead)){
		token = token*8 + (look_ahead - '0');
		look_ahead = getc(IN);
	}
}

in_dec()
{
	token = 0;
	while (isdec(look_ahead)){
		token = token*10 + (look_ahead - '0');
		look_ahead = getc(IN);
	}
}


/* spits out input file until '>>' found */
scarf_action()
{
more:	while ((token = getc(IN))!=EOF && token!='>'){
		if (token == '\n'){
			++line_no;
			}
		putc(token,OUT);
		}
	/* could be EOF or '>' */
	switch (token){
	case EOF:	token = LEX_EOF;
			look_ahead = EOF;
			return;
			break;
	case '>':	if ((look_ahead = getc(IN)) == '>'){
				/* end of action */
				putc('\n',OUT);
				token = GREAT_GREAT;
				look_ahead = EOF;
				return;
				}
			else{
				/* false alarm, just one '>', not '>>' */
				putc(token,OUT);
				putc(look_ahead,OUT);
				}
			goto more;
	}
}
