/* routines that print out stuff
 *
 * Will Cohen
 * 10/26/89
 *
 * for ee595e
 *
 * most of these are pretty simple.
 */

#include <stdio.h>
#include "tokens.h"
#include "dlg.h"

#define MAX_ON_LINE 11

/* This section is MACHINE DEPENDENT */
#define DIF_SIZE
long typesize[DIF_SIZE]  = { 0x7f, 0x7fff, 0x7fffffff, 0x7fffffff };
char t0[] = "unsigned char";
char t1[] = "unsigned short";
char t2[] = "unsigned int";
char t3[] = "unsigned long";
char *typevar[DIF_SIZE] = { t0, t1, t2, t3};


print_head()
{
	fprintf(OUT,"static FILE *inputStream;\n");
	fprintf(OUT,"char LexText[LEX_BUF];\n");
	fprintf(OUT,"static int lex_c = ' ';\n");
	fprintf(OUT,"static int lex_mode;\n");
	fprintf(OUT,"int lex_line = 1;\n");
	fprintf(OUT,"\n");
	/* LEX_EOF is probably not right */
	fprintf(OUT,"\n#define LEX_EOF -1\n");
	if (compress)
		fprintf(OUT,"unsigned char shift[];\n");
	fprintf(OUT,"int (*actions[])();\n");
}

print_tail()
{
}

/* output the table of DFA for general use */
print_tables()
{
	char *minsize();

	fprintf(OUT,"#define DfaStates\t%d\n",dfa_pool);
	fprintf(OUT,"#define NumAtoms\t%d\n", class_no);
	fprintf(OUT,"typedef %s DfaState;\n\n",minsize(dfa_pool));
	fprintf(OUT,"DfaState accepts[];\n");
	fprintf(OUT,"DfaState *dfa[];\n\n");

	print_node_table();
	print_dfa_table();
	print_accept_table();
	print_action_table();
	if (compress)
		print_shift_table();
	fprintf(OUT,"\n");
	fprintf(OUT,"\n");
	if (compress)
		fprintf(OUT,"#define _SHIFT(c) ((&shift[1])[c])\n");
	else
		fprintf(OUT,"#define _SHIFT(c) (1+c)\n");
	fprintf(OUT,"#include \"dlgauto.h\"\n");
}

/* figures out the smallest variable type that will hold the transitions
 */
char *minsize(elements)
int elements;
{
	int i = 0;

	while (elements > typesize[i])
		++i;
	return typevar[i];
		
}

print_node_table()
{
	register int	i, j;
	register int	trans, items_on_line;

	for (i = 0; i<dfa_pool; i++){
		fprintf(OUT,"static DfaState st%d[NumAtoms] = {\n  ",i);
		items_on_line = 0;
		j = 0;
		while(TRUE){
			trans = (int) dfa_array[i].trans[j];
			if (trans == NIL_INDEX)
				trans = dfa_pool;
			fprintf(OUT,"%d", trans);
			if ((++j) >= class_no)
				break;
			fprintf(OUT,", ");
			if ((++items_on_line)>MAX_ON_LINE){
				fprintf(OUT,"\n  ");
				items_on_line = 0;
				}
			}
		fprintf(OUT,"\n};\n\n");
		}
}

print_dfa_table()
{
	register int	i;

	fprintf(OUT,"\nDfaState *dfa[%d] = {\n",dfa_pool);
	for (i = 0; i<(dfa_pool-1); i++){
		fprintf(OUT,"\tst%d,\n",i);
		}
	fprintf(OUT,"\tst%d\n",i);
	fprintf(OUT,"};\n\n");
}

print_accept_table()
{
	register int	i = 0;
	register int	items_on_line = 0;

	fprintf(OUT,"\nDfaState accepts[%d] = {\n",dfa_pool);
	while (TRUE){
		int accept = 0;
		set nfa_states;
		register int nfa_index;
		register unsigned *start = &(nfa_states.setword[0]);

		nfa_states = dfa_array[i].nfa_states;
		set_remove_int(nfa_states,nfa_index,start);
		while(nfa_index != nil){
			accept = nfa(nfa_index).accept;
			if (accept)
				break;
			set_remove_int(nfa_states,nfa_index,start);
			}
		fprintf(OUT,"%d",accept);
		if ((++i)>=dfa_pool)
			break;
		fprintf(OUT,", ");
		if ((++items_on_line)>MAX_ON_LINE){
			fprintf(OUT,"\n  ");
			items_on_line = 0;
			}
		}
	fprintf(OUT,"\n};\n\n");
}

print_action_table()
{
	register int	i;

	fprintf(OUT,"int (*actions[%d])() = {\n",action_no+1);
	fprintf(OUT,"\taction0,\n");
	for (i = 1; i<action_no; i++){
		fprintf(OUT,"\tact%d,\n",i);
		}
	fprintf(OUT,"\tact%d\n",i);
	fprintf(OUT,"};\n\n");
}

print_shift_table()
{
	register int	i = 0, j;
	register int	items_on_line = 0;

	fprintf(OUT,"unsigned char shift[%d] = {\n  ",LAST_CHAR+2);
	while (TRUE){
		/* find which partition character i is in */
		for (j = 0; j<class_no; j++){
			if (set_el(i,class[j]))
				break;
			}
		fprintf(OUT,"%d",j);
		if ((++i)>(LAST_CHAR+1))
			break;
		fprintf(OUT,", ");
		if ((++items_on_line)>MAX_ON_LINE){
			fprintf(OUT,"\n  ");
			items_on_line = 0;
			}
		}
	fprintf(OUT,"\n};\n\n");
}

print_nfa_node(p)
int p;	/* state number also index into array */
{
	 register nfa_node *t;

	if (p != NIL_INDEX){
		t = &(nfa_array[p]);
		printf("NFA state : %d\naccept state : %d\n",
			p,t->accept);
		if (t->trans[0] != NIL_INDEX){
			printf("trans[0] => %d on ", t->trans[0]);
			print_set(t->label);
			printf("\n");
			}
		else
			printf("trans[0] => nil\n");
		if (t->trans[1] != NIL_INDEX)
			printf("trans[1] => %d on epsilon\n", t->trans[1]);
		else
			printf("trans[1] => nil\n");
		printf("\n");
		}
}

print_set(label)
set label;
{
	register int c;
	register unsigned *start = &(label.setword[0]);

	if (set_nil(label))
		printf("epsilon ");
	else{
		c = nil;
		set_remove_int(label,c,start);
		while (c != nil){
			printf("%d ",c);
			set_remove_int(label,c,start);
			}
		}
}

print_nfa(p)
int p;	/* state number also index into array */
{
/* each node has a marker on it so it only gets printed once */

	++nfa_set; /* get new number */

	s_print_nfa(p);
}

s_print_nfa(p)
int p;	/* state number also index into array */
{
	if ((p != NIL_INDEX) && nfa_array[p].nfa_set != nfa_set){
		nfa_array[p].nfa_set = nfa_set; /* so it is only printed once */
		print_nfa_node(p);
		s_print_nfa(nfa_array[p].trans[0]);
		s_print_nfa(nfa_array[p].trans[1]);
		}
}

print_dfa_node(p)
int p;
{
	int i;

	if (p != NIL_INDEX){
		printf("DFA state :%d\n",p);
		if (dfa_array[p].done)
			printf("done\n");
		else
			printf("undone\n");
		printf("from nfa states : ");
		print_set(dfa_array[p].nfa_states);
		printf("\n");
		for (i=0; i<NUM_CLASS; i++){
			printf("%d ",dfa_array[p].trans[i]);
			}
		printf("\n\n");
		}
}

print_dfa()
{
/* prints out all the dfa nodes actually allocated */

	int i;

	for (i = 0; i<dfa_pool;i++)
		print_dfa_node(i);
}
