/* Trax.h -- Trace Allocation functions */

#ifndef NULL
#define NULL	0
#endif

typedef struct _trax {
			int size, line, code;
			char *file;
			unsigned long mword;
			struct _trax *prev, *next;
		} Trax;

#define ValidBuf		((unsigned long) 0x12345678)
#define MagicWd1		((char) 0x12)
#define MagicWd2		((char) 0x34)
#define odd(addr)		(((unsigned)(addr)) & 1)
/*
#define alignUP(p)		((p)+odd(p))
#define alignDN(p)		((p)-odd(p))
*/
#define mInfo(p)		((Trax *) (((char *)(p))-sizeof(Trax)))
#define magic1(p)		( *(((char *)(p)) + sizeof(Trax) + msize(p)) )
#define magic2(p)		( *(((char *)(p)) + sizeof(Trax) + msize(p) + 1) )
#define corrupt(p)		(magic1(p) != MagicWd1 && magic2(p) != MagicWd1)
#define valid(p)		(mInfo(p)->mword == ValidBuf)
#define msize(p)		(mInfo(p)->size)

#define malloc(n)		mMalloc(n, 0, __FILE__, __LINE__)
#define realloc(p, n)	mRealloc(p, n, __FILE__, __LINE__)
#define mallocx(n,t)	mMalloc(n, t, __FILE__, __LINE__)
#define calloc(n,s)		mCalloc(n, s, 0, __FILE__, __LINE__)
#define callocx(n,s,t)	mCalloc(n, s, t, __FILE__, __LINE__)
#define free(p)			mFree(p, __FILE__, __LINE__)

char	*mMalloc(),
		*mCalloc(),
		*mRealloc();
unsigned	mMax, mCur, mTotal;

