#include <stdio.h>
#include "gen.h"
#include "sym.h"
#include "dlgdef.h"

/* C o d e  G e n e r a t o r */

char *calloc();

char *howTo[] =
{
	"%s:\n",				/* Label */
	"\tPUSH\t0\n",			/* Local */
	"%s:\n\tWORD\t0\n",		/* Global */
	"\tRET\n",				/* Return */
	"\tADD\n",				/* Add */
	"\tMUL\n",				/* Mult */
	NULL,					/* Ref */
	"\tNEG\n",				/* Neg */
	"\tPUSH\t%s\n",			/* Push */
	"\tAFP\n",				/* Afp */
	"\tIND\n",				/* Ind */
	"\tCALL\n",				/* Call */
	"\tPOP\n",				/* Pop */
	"\tJUMP\t%s\n",			/* Jump */
	"\tJUMPZ\t%s\n",		/* JumpZ */
	"\tTEST\n"				/* Test */
};

gen(action, ptr, type)
int action;
Sym *ptr;
int type;
{
	/* V a r i a b l e  R e f e r e n c e ? */
	if ( action == Ref )
	{
		if ( ptr == NULL ) {Cerror("Hmmm...gen() fatal\n"); exit(-1);}
		/* F u n c t i o n ? */
		if ( ptr->executable )
		{
			gen(Push, ptr->symbol);
			return;
		}
		if ( ptr->level == GLOBAL )
		{
			gen(Push, ptr->symbol);
			if ( type == Value ) gen(Ind);
		}
		else
		{
			gen(Push, str(ptr->offset));
			gen(Afp);
			if ( type == Value ) gen(Ind);
		}
		return;
	}
	
	printf(howTo[action], ptr);
}

char *
NewLabel()
{
	static char label[LabelSize+1];
	static int num = 0;
	
	sprintf(label, "_L%03d", ++num);
	return( label );
}

char *
str(i)
int i;
{
	static char buf[LabelSize+1];

	sprintf(buf, "%d", i);
	return(buf);
}

Cerror(err, a1, a2, a3)
char *err, *a1, *a2, *a3;
{
	fprintf(stderr, "stdin, line %d: ", lex_line);
	fprintf(stderr, err, a1, a2, a3);
}

